<template>
    <div class="left__top--three animated fadeInLeft">
        <div class="three__top">
            <div class="three__top--svg">
                <svg class="noActive">
                    <use xlink:href="/img/sprite.svg#increase-size-option"/>
                </svg>
                <svg class="noActive" :class="activeTypeClass('bar')" @click="selectType('bar')">
                    <use xlink:href="/img/sprite.svg#stats"/>
                </svg>
                <svg class="noActive" :class="activeTypeClass('line')" @click="selectType('line')">
                    <use xlink:href="/img/sprite.svg#chart"/>
                </svg>
            </div>
            <ui-filter class="three__top--right" :options="times" v-model="time" v-show="display"/>
        </div>
        <div class="box_graphick" v-show="display">
            <line-chart :chart_data="line_data" :is_currency="is_currency" v-if="chart_type === 'line'" :range="time"></line-chart>
            <bar-chart :chart_data="line_data" :is_currency="is_currency" v-if="chart_type === 'bar'" :range="time"></bar-chart>
            <div class="downLink">
                <a href="#" class="link-filter" :class="{activeFilter: type === 'refills'}" @click="setType('refills')" v-if="stats.hasOwnProperty('refills')">
                    <svg><use xlink:href="/img/sprite.svg#two-stacks-of-coins"/></svg> {{ $t('dashboard.operations.refills') }}
                </a>
                <a href="#" class="link-filter" :class="{activeFilter: type === 'users'}" @click="setType('users')" v-if="stats.hasOwnProperty('users')">
                    {{ $t('dashboard.operations.users') }}
                </a>
                <a href="#" class="link-filter" :class="{activeFilter: type === 'withdraws'}" @click="setType('withdraws')" v-if="stats.hasOwnProperty('withdraws')">
                    {{ $t('dashboard.operations.withdraws') }}
                </a>
            </div>
        </div>
    </div>
</template>

<script>
    import _ from 'lodash';
    import LineChart from "../charts/LineChart";
    import BarChart from "../charts/BarChart";
	export default {
		props: {
		    stats: {
		    	type: Object,
                default: function (){
                	return { };
                }
            }
        },
		data(){
			return {
				times: {
					days: this.$t('ui.date_intervals.daily'),
                    two_days: this.$t('ui.date_intervals.two_days'),
                    weeks: this.$t('ui.date_intervals.weekly'),
                    months: this.$t('ui.date_intervals.monthly')
                },
                time: 'days',
                types: {
					refills: this.$t('dashboard.operations.refills'),
					users: this.$t('dashboard.operations.users'),
					withdraws: this.$t('dashboard.operations.withdraws'),
                },
                type: 'refills',
                chart_type: 'line',
                is_currency: true,
            }
        },
        computed: {
		    display(){
                return !!_.size(this.stats);
            },
            line_data(){
		        if(!this.stats.hasOwnProperty(this.type)){
		            console.log('type not exist');
		            return [];
                }
		        if(!this.stats[this.type].hasOwnProperty(this.time)){
                    console.log('time not exist');
		            return [];
                }
                return _.map(this.stats[this.type][this.time], (value, key) => {
                    return [key, value];
                });
            }
        },
        methods: {
			setType(type){
				this.type = type;
				this.is_currency = type !== 'users';
            },
			setTime(time){
				this.time = time;
            },
            activeTypeClass(type){
                return {
                    'yesActive': this.chart_type === type
                }
            },
            selectType(type){
                this.chart_type = type;
            }
        },
        components: {
		    LineChart,
            BarChart
        }
	}
</script>

<style scoped>
    .three__top--right{
        margin-right: 20px;
    }
</style>
